{% if search_index_import_scripts_python_webservice_install %}
upstream import_scripts_gunicorn {
  server unix:/run/gunicorn.sock;
}
{% endif %}
server {
  listen       80;
  server_name  localhost;
{% if kibana_install and kibana_public %}
  location {{ search_index_public_base_path }}/kibana {
    proxy_pass http://localhost:{{ kibana_server_port | default("5601", true) }};
  }
{% endif %}
  location {{ search_index_backend_contactapi_root_path }} {
    proxy_pass {{ search_index_backend_internal_api_base_url }}/contact;
  }
  location {{ search_index_backend_searchapi_root_path }} {
    proxy_pass {{ search_index_backend_internal_api_base_url }}/search/;
  }
  location {{ search_index_backend_labelapi_root_path }} {
    proxy_pass {{ search_index_backend_internal_api_base_url }}/label/;
  }
  location {{ search_index_backend_oembedapi_root_path }}-json {
    proxy_pass {{ search_index_backend_internal_api_base_url }}/oembed-json;
  }
  location {{ search_index_backend_oembedapi_root_path }}-xml {
    proxy_pass {{ search_index_backend_internal_api_base_url }}/oembed-xml;
  }
  location {{ search_index_backend_oembedapi_root_path }} {
    proxy_pass {{ search_index_backend_internal_api_base_url }}/oembed-json;
  }
{% if search_index_import_scripts_python_webservice_install %}
  location {{ search_index_public_base_path }}/api-internal/import-scripts/python/ {
    proxy_set_header X-Forwarded-For $proxy_add_x_forwarded_for;
    proxy_set_header X-Forwarded-Proto $scheme;
    proxy_set_header Host $http_host;
    proxy_redirect off;
    proxy_pass http://import_scripts_gunicorn/;
  }
{% endif %}
  location ~ "^{{ search_index_public_base_path }}/((?:[A-Za-z0-9-_]{4}+){4,}(?:[A-Za-z0-9-_]{3}=|[A-Za-z0-9-_]{2}==)?)$" {
    # if-workaround, see https://www.nginx.com/resources/wiki/start/topics/depth/ifisevil/
    error_page 418 = @json_resource;
    error_page 419 = @html_resource;
    
    set $resourceId $1;
    set $requestedJson n;
    if ($http_accept ~ "application/json") {
      set $requestedJson "y";
    }
    if ($arg_format = "json") {
      set $requestedJson "y";
    }
    if ($requestedJson = "y") {
      return 418;
    }
    return 419;
  }
  location @json_resource {
    proxy_pass {{ search_index_backend_internal_api_base_url }}/search/{{ elasticsearch_metadata_index_alias_name }}/_source/$resourceId;
  }
  location @html_resource {
{% if search_index_frontend_features_use_ssr %}
    proxy_pass http://127.0.0.1:3000{{ search_index_public_base_path }}/$resourceId;
{% else %}
    proxy_pass http://127.0.0.1{{ search_index_public_base_path }}/details/$resourceId;
{% endif %}
  }
  location ~ "^{{ search_index_public_base_path }}/(sitemap.*\.xml(\.gz)?)$" {
    gzip_static on;
    alias {{ search_index_frontend_sitemap_dir }}/$1;
  }
  location {{ search_index_public_base_path }}/vocabs {
    gzip_static on;
    alias {{ search_index_frontend_vocabs_dir }};
    expires 1d;
    add_header Cache-Control "public";
  }
{% if search_index_features_generate_thumbnails %}
  location {{ search_index_public_base_path }}/thumbnail {
    gzip_static on;
    alias {{ thumbnail_webserver_instdir }};
    try_files $uri $uri/ =404;
    expires 7d;
    add_header Cache-Control "public";
  }
{% endif %}
{% if search_index_features_create_dump %}
  location {{ search_index_public_base_path }}/dumps {
    types {
        application/x-ndjson ndjson;
    }
    gzip_static on;
    alias {{ search_index_dumps_instdir }};
    try_files $uri $uri/ =404;
    expires 7d;
    add_header Cache-Control "public";
    autoindex on;
  }
{% endif %}
  location = {{ search_index_public_base_path }}/api/applicationInfo {
    default_type application/json;
    gzip_static on;
    alias {{ search_index_webserver_root_folder }}/applicationInfo.json;
  }
  location {{ search_index_public_base_path }}/api-internal/versions.json {
    return 301 {{ search_index_public_base_path }}/api/applicationInfo;
  }
{% if search_index_frontend_features_use_ssr %}
  location {{ search_index_public_base_path }} {
    proxy_pass http://127.0.0.1:3000;
  }
{% else %}
  location {{ search_index_public_base_path }}/static {
    alias {{ search_index_frontend_public_dir }}/static;
    expires 1y;
    add_header Cache-Control "public, immutable";
  }
  location {{ search_index_public_base_path }}/footer {
    gzip_static on;
    alias {{ search_index_frontend_public_dir }}/footer;
    expires 1d;
    add_header Cache-Control "public";
  }
  location {{ search_index_public_base_path }} {
    gzip_static on;
    alias {{ search_index_frontend_public_dir }};
    index  index.html;
    try_files $uri $uri/ /index.html =404;
    add_header Cache-Control "no-store, no-cache, must-revalidate";
  }
{% endif %}
  location / {
    return 301 {{ search_index_public_base_path }};
  }
  try_files $uri $uri/ /index.html;
  error_page   500 502 503 504  /50x.html;
  location = /50x.html {
    root   /usr/share/nginx/html;
  }
}
